<template>
  <!-- 
    普通编辑窗体
    v 1.2
    2021-04-30
    Lufthafen
  -->
  <a-form-model :model="form" :rules="rules" class="yo-form" ref="form">
    <a-spin :spinning="loading">
      <a-icon slot="indicator" spin type="loading" />
      <div class="yo-form-group">
        <a-form-model-item label="所属组织机构" prop="sysEmpParam.orgId" v-if="form.sysEmpParam">
          <a-tree-select
            :dropdown-style="{ maxHeight: '300px', overflow: 'auto' }"
            :tree-data="orgData"
            @change="onOrgChange"
            placeholder="请选择所属组织机构"
            tree-default-expand-all
            v-model="form.sysEmpParam.orgId"
          />
        </a-form-model-item>
        <a-form-model-item prop="roleId">
          <span slot="label">
            角色
            <a-tooltip title="片区内第一个用户必定为片区监管员，创建后不可更改角色">
              <a-icon theme="twoTone" type="info-circle" />
            </a-tooltip>
          </span>
          <a-select :disabled="lockRole" placeholder="请选择角色" v-model="form.roleId">
            <a-select-option :key="item.id" :value="item.id" v-for="item in roleData">{{item.name}}</a-select-option>
          </a-select>
        </a-form-model-item>
        <a-form-model-item label="账号" prop="account">
          <a-input placeholder="请输入账号" v-model="form.account" />
        </a-form-model-item>
        <a-form-model-item label="姓名" prop="name">
          <a-input placeholder="请输入姓名" v-model="form.name" />
        </a-form-model-item>
        <template v-if="mode == 'add'">
          <a-form-model-item label="密码" prop="password">
            <a-input-password placeholder="请输入密码" v-model="form.password" />
          </a-form-model-item>
          <a-form-model-item label="确认密码" prop="confirm">
            <a-input-password placeholder="请确认密码" v-model="form.confirm" />
          </a-form-model-item>
        </template>
        <a-form-model-item label="昵称">
          <a-input placeholder="请输入昵称" v-model="form.nickName" />
        </a-form-model-item>
        <a-form-model-item label="生日">
          <a-date-picker
            @change="(date) => (form.birthday = date ? $moment(date).format('YYYY-MM-DD') : null)"
            class="w-100-p"
            placeholder="请选择生日"
            v-model="form.birthday"
          />
        </a-form-model-item>
        <a-form-model-item label="性别" prop="sex">
          <a-radio-group v-model="form.sex">
            <a-radio-button :value="0">
              <a-icon class="mr-xxs" type="stop" />
              <span>保密</span>
            </a-radio-button>
            <a-radio-button :value="1">
              <a-icon :style="{ color: '#1890ff' }" class="mr-xxs" type="man" />
              <span>男</span>
            </a-radio-button>
            <a-radio-button :value="2">
              <a-icon :style="{ color: '#eb2f96' }" class="mr-xxs" type="woman" />
              <span>女</span>
            </a-radio-button>
          </a-radio-group>
        </a-form-model-item>
        <a-form-model-item label="邮箱" prop="email">
          <a-input placeholder="请输入邮箱" v-model="form.email" />
        </a-form-model-item>
        <a-form-model-item label="手机号" prop="phone">
          <a-input placeholder="请输入手机号" v-model="form.phone" />
        </a-form-model-item>
        <a-form-model-item label="电话" prop="tel">
          <a-input placeholder="请输入电话" v-model="form.tel" />
        </a-form-model-item>
      </div>
    </a-spin>
  </a-form-model>
</template>
<script>
const validateToNextPassword = (rule, value, callback) => {
  callback();
};
const compareToFirstPassword = (rule, value, callback) => {
  callback();
};

/* 表单内容默认值 */
const defaultForm = {
  /* ... */
  sex: 0,
  sysEmpParam: {},
};

export default {
  props: {
    mode: {
      type: String,
      default: 'edit',
    },
  },

  data() {
    return {
      /** 表单数据 */
      form: {},
      /** 验证格式 */
      rules: {
        /* ... */
        roleId: [{ required: true, message: '请选择角色' }],
        account: [{ required: true, min: 5, message: '请输入至少五个字符的账号', trigger: 'blur' }],
        name: [{ required: true, message: '请输入姓名', trigger: 'blur' }],
        password: [
          { required: true, min: 5, message: '请输入至少五个字符的密码', trigger: 'blur' },
          { validator: validateToNextPassword, trigger: 'blur' },
        ],
        confirm: [
          { required: true, message: '请确认密码', trigger: 'blur' },
          { validator: compareToFirstPassword, trigger: 'blur' },
        ],
        phone: [
          {
            pattern: /^((13[0-9])|(14[5,7])|(15[^4,\\D])|(17[0,1,3,6-8])|(18[0-9])|(19[8,9])|(166))[0-9]{8}$/,
            message: '手机号格式不正确',
            trigger: 'blur',
          },
        ],
        email: [
          { pattern: /^\w{3,}(\.\w+)*@[A-z0-9]+(\.[A-z]{2,5}){1,2}$/, message: '邮箱格式不正确', trigger: 'blur' },
        ],
        'sysEmpParam.orgId': [{ required: true, message: '请选择所属组织机构' }],
        'sysEmpParam.posIdList': [{ required: true, message: '请选择职位信息' }],
      },

      /** 加载异步数据状态 */
      loading: false,

      /** 其他成员属性 */
      /* ... */
      orgData: [],
      roleData: [],

      defaultRole: undefined,
      lockRole: false,
    };
  },

  methods: {
    /**
     * 必要的方法
     * 在打开编辑页时允许填充数据
     */
    onFillData(params) {
      const form = this.$_.cloneDeep(params.record || {});
      // 日期特殊处理
      if (form.birthday) {
        form.birthday = this.$moment(form.birthday).format('YYYY-MM-DD');
      }
      // 提交的时候是"param",而获取下来却是"info",在这里转换一下
      if (form.sysEmpInfo) {
        form.sysEmpParam = form.sysEmpInfo;
        delete form.sysEmpInfo;
      } else if (!form.sysEmpParam) {
        form.sysEmpParam = {
          extIds: [],
        };
      }
      // 转换职位信息列表
      if (form.sysEmpParam.positions) {
        form.sysEmpParam.posIdList = form.sysEmpParam.positions.map((p) => p.posId);
      }
      // 附加信息
      if (form.sysEmpParam.extOrgPos) {
        form.sysEmpParam.extIds = form.sysEmpParam.extOrgPos.map((p, i) => {
          return {
            key: i,
            orgId: p.orgId,
            posId: p.posId,
          };
        });
      }

      if (params.orgId) {
        form.sysEmpParam.orgId = params.orgId;
      }

      if (this.defaultRole.constructor === Array) {
        form.roleId = this.defaultRole[0];
      } else {
        form.roleId = this.defaultRole.id;
      }

      this.doLockRole();

      /** 将默认数据覆盖到form */
      this.form = this.$_.cloneDeep({
        ...defaultForm,
        ...form,
        /** 在此处添加其他默认数据转换 */
        /* ... */
      });
    },

    /**
     * 必要方法
     * 验证表单并获取表单数据
     */
    onGetData() {
      return new Promise((reslove, reject) => {
        this.$refs.form.validate((valid) => {
          if (valid) {
            const record = this.$_.cloneDeep(this.form);

            /** 验证通过后可以对数据进行转换得到想要提交的格式 */
            /* ... */

            reslove(record);
          } else {
            reject();
          }
        });
      });
    },

    /**
     * 必要的方法
     * 在外部窗口进行保存时调用表单验证
     */
    onValidate(callback) {
      this.$refs.form.validate(callback);
    },

    /**
     * 必要的方法
     * 在外部窗口关闭或重置时对表单验证进行初始化
     */
    onResetFields() {
      setTimeout(() => {
        this.$refs.form.resetFields();

        /** 在这里可以初始化当前组件中其他属性 */
        /* ... */
        this.form = {
          ...defaultForm,
        };

        this.defaultRole = undefined;
        this.lockRole = false;
      }, 300);
    },

    /**
     * 必要方法
     * 加载当前表单中所需要的异步数据
     */
    async onInit(params) {
      this.loading = true;
      /** 可以在这里await获取一些异步数据 */
      /* ... */
      this.orgData = await this.onLoadOrgData();
      this.roleData = await this.onLoadDefaultRoleList();
      if (params.record) {
        this.defaultRole = await this.onLoadOwnRole(params.record.id);
      } else {
        this.defaultRole = await this.onLoadDefaultRole(params.orgId);
      }
      this.loading = false;
    },

    /** 当前组件的其他方法 */
    /* ... */

    onLoadOrgData() {
      return this.$api.getOrgTree().then(({ data }) => {
        return data;
      });
    },

    onLoadDefaultRole(orgId) {
      return this.$api.houseMemberDefaultRole({ orgId }).then(({ data }) => {
        return data;
      });
    },

    onLoadDefaultRoleList() {
      return this.$api.houseMemberDefaultRoleList().then(({ data }) => {
        return data;
      });
    },

    onLoadOwnRole(id) {
      return this.$api.houseMemberOwnRole({ id }).then(({ data }) => {
        return data;
      });
    },

    async onOrgChange(orgId) {
      this.loading = true;
      if (!this.form.roleName) {
        this.defaultRole = await this.onLoadDefaultRole(orgId);
        this.form.roleId = this.defaultRole.id;
        this.doLockRole();
      }
      this.loading = false;
    },

    doLockRole() {
      if (this.defaultRole.constructor === Array) {
        this.lockRole = true;
      } else {
        this.lockRole = this.defaultRole.code === 'zone_manager';
      }
    },
  },
};
</script>